Index: codecs/codec_g726.c
===================================================================
--- codecs/codec_g726.c	(revision 87233)
+++ codecs/codec_g726.c	(working copy)
@@ -894,14 +894,16 @@
 	.buf_size = BUFFER_SAMPLES,
 };
 
-static void parse_config(int reload)
+static int parse_config(int reload)
 {
 	struct ast_variable *var;
 	struct ast_flags config_flags = { reload ? CONFIG_FLAG_FILEUNCHANGED : 0 };
 	struct ast_config *cfg = ast_config_load("codecs.conf", config_flags);
 
-	if (cfg == NULL || cfg == CONFIG_STATUS_FILEUNCHANGED)
-		return;
+	if (cfg == NULL)
+		return -1;
+	if (cfg == CONFIG_STATUS_FILEUNCHANGED)
+		return 0;
 	for (var = ast_variable_browse(cfg, "plc"); var; var = var->next) {
 		if (!strcasecmp(var->name, "genericplc")) {
 			g726tolin.useplc = ast_true(var->value) ? 1 : 0;
@@ -910,13 +912,14 @@
 		}
 	}
 	ast_config_destroy(cfg);
+	return 0;
 }
 
 static int reload(void)
 {
-	parse_config(1);
-
-	return 0;
+	if (parse_config(1))
+		return AST_MODULE_LOAD_DECLINE;
+	return AST_MODULE_LOAD_SUCCESS;
 }
 
 static int unload_module(void)
@@ -940,7 +943,8 @@
 	int res = 0;
 
 
-	parse_config(0);
+	if (parse_config(0))
+		return AST_MODULE_LOAD_DECLINE;
 
 	res |= ast_register_translator(&g726tolin);
 	res |= ast_register_translator(&lintog726);
@@ -951,10 +955,12 @@
 	res |= ast_register_translator(&g726aal2tog726);
 	res |= ast_register_translator(&g726tog726aal2);
 
-	if (res)
+	if (res) {
 		unload_module();
+		return AST_MODULE_LOAD_FAILURE;
+	}	
 
-	return res;
+	return AST_MODULE_LOAD_SUCCESS;
 }
 
 AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "ITU G.726-32kbps G726 Transcoder",
